3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|*' --va'*)
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
45 # A call to "unset" with no arguments causes at least Solaris 10
46 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
47 # deriving from the command substitution clustered with the other
49 unset VISUAL EMAIL LANGUAGE COLUMNS $(perl -e '
51 my $ok = join("|", qw(
59 PERF_AGGREGATING_LATER
61 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
62 print join("\n", @vars);
64 GIT_AUTHOR_EMAIL=author@example.com
65 GIT_AUTHOR_NAME='A U Thor'
66 GIT_COMMITTER_EMAIL=committer@example.com
67 GIT_COMMITTER_NAME='C O Mitter'
70 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
71 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
72 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
75 # Protect ourselves from common misconfiguration to export
76 # CDPATH into the environment
81 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
83 echo "* warning: Some tests will not work if GIT_TRACE" \
84 "is set as to trace on STDERR ! *"
85 echo "* warning: Please set GIT_TRACE to something" \
86 "other than 1, 2 or true ! *"
92 # A regexp to match 5 and 40 hexdigits
93 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
94 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
97 _z40=0000000000000000000000000000000000000000
103 export _x05 _x40 _z40 LF
105 # Each test should start with something like this, after copyright notices:
107 # test_description='Description of this test...
108 # This test checks if command xyzzy does the right thing...
111 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
112 TERM=$ORIGINAL_TERM &&
115 tput bold >/dev/null 2>&1 &&
116 tput setaf 1 >/dev/null 2>&1 &&
117 tput sgr0 >/dev/null 2>&1
121 while test "$#" -ne 0
124 -d|--d|--de|--deb|--debu|--debug)
126 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
127 immediate=t; shift ;;
128 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
129 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
130 -h|--h|--he|--hel|--help)
132 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
134 -q|--q|--qu|--qui|--quie|--quiet)
135 # Ignore --quiet under a TAP::Harness. Saying how many tests
136 # passed without the ok/not ok details is always an error.
137 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
139 with_dashes=t; shift ;;
142 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
143 valgrind=t; verbose=t; shift ;;
145 shift ;; # was handled already
147 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
150 echo "error: unknown test option '$1'" >&2; exit 1 ;;
154 if test -n "$color"; then
160 error) tput bold; tput setaf 1;; # bold red
161 skip) tput bold; tput setaf 2;; # bold green
162 pass) tput setaf 2;; # green
163 info) tput setaf 3;; # brown
164 *) test -n "$quiet" && return;;
174 test -z "$1" && test -n "$quiet" && return
181 say_color error "error: $*"
190 test "${test_description}" != "" ||
191 error "Test script did not set test_description."
193 if test "$help" = "t"
195 echo "$test_description"
201 if test "$verbose" = "t"
205 exec 4>/dev/null 3>/dev/null
214 test_external_has_tap=0
218 if test -n "$GIT_EXIT_OK"
222 echo >&5 "FATAL: Unexpected exit with code $code"
230 # The user-facing functions are loaded from a separate file so that
231 # test_perf subshells can have them too
232 . "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
234 # You are not expected to call test_ok_ and test_failure_ directly, use
235 # the text_expect_* functions instead.
238 test_success=$(($test_success + 1))
239 say_color "" "ok $test_count - $@"
243 test_failure=$(($test_failure + 1))
244 say_color error "not ok - $test_count $1"
246 echo "$@" | sed -e 's/^/# /'
247 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
250 test_known_broken_ok_ () {
251 test_fixed=$(($test_fixed+1))
252 say_color "" "ok $test_count - $@ # TODO known breakage"
255 test_known_broken_failure_ () {
256 test_broken=$(($test_broken+1))
257 say_color skip "not ok $test_count - $@ # TODO known breakage"
261 test "$debug" = "" || eval "$1"
265 # This is a separate function because some tests use
266 # "return" to end a test_expect_success block early.
267 eval </dev/null >&3 2>&4 "$*"
276 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
278 test_eval_ "$test_cleanup"
280 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
287 test_count=$(($test_count+1))
289 for skp in $GIT_SKIP_TESTS
291 case $this_test.$test_count in
297 if test -z "$to_skip" && test -n "$test_prereq" &&
298 ! test_have_prereq "$test_prereq"
305 if test "$missing_prereq" != "$test_prereq"
307 of_prereq=" of $test_prereq"
310 say_color skip >&3 "skipping test: $@"
311 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
320 # stub; perf-lib overrides it
321 test_at_end_hook_ () {
328 if test -z "$HARNESS_ACTIVE"; then
329 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
330 mkdir -p "$test_results_dir"
331 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
333 cat >>"$test_results_path" <<-EOF
335 success $test_success
343 if test "$test_fixed" != 0
345 say_color pass "# fixed $test_fixed known breakage(s)"
347 if test "$test_broken" != 0
349 say_color error "# still have $test_broken known breakage(s)"
350 msg="remaining $(($test_count-$test_broken)) test(s)"
352 msg="$test_count test(s)"
354 case "$test_failure" in
356 # Maybe print SKIP message
357 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
359 if test $test_external_has_tap -eq 0; then
360 say_color pass "# passed all $msg"
361 say "1..$test_count$skip_all"
364 test -d "$remove_trash" &&
365 cd "$(dirname "$remove_trash")" &&
366 rm -rf "$(basename "$remove_trash")"
373 if test $test_external_has_tap -eq 0; then
374 say_color error "# failed $test_failure among $msg"
383 # Test the binaries we have just built. The tests are kept in
384 # t/ subdirectory and are run in 'trash directory' subdirectory.
385 if test -z "$TEST_DIRECTORY"
387 # We allow tests to override this, in case they want to run tests
388 # outside of t/, e.g. for running tests on the test library
390 TEST_DIRECTORY=$(pwd)
392 if test -z "$TEST_OUTPUT_DIRECTORY"
394 # Similarly, override this to store the test-results subdir
396 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
398 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
400 if test -n "$valgrind"
404 test "$1" = "$(readlink "$2")" || {
412 while test -d "$2".lock
414 say "Waiting for lock on $2."
421 make_valgrind_symlink () {
422 # handle only executables, unless they are shell libraries that
423 # need to be in the exec-path. We will just use "#!" as a
424 # guess for a shell-script, since we have no idea what the user
425 # may have configured as the shell path.
427 test "#!" = "$(head -c 2 <"$1")" ||
430 base=$(basename "$1")
431 symlink_target=$GIT_BUILD_DIR/$base
432 # do not override scripts
433 if test -x "$symlink_target" &&
434 test ! -d "$symlink_target" &&
435 test "#!" != "$(head -c 2 < "$symlink_target")"
437 symlink_target=../valgrind.sh
441 symlink_target=../unprocessed-script
443 # create the link, or replace it if it is out of date
444 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
447 # override all git executables in TEST_DIRECTORY/..
448 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
449 mkdir -p "$GIT_VALGRIND"/bin
450 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
452 make_valgrind_symlink $file
454 # special-case the mergetools loadables
455 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
460 ls "$path"/git-* 2> /dev/null |
463 make_valgrind_symlink "$file"
467 PATH=$GIT_VALGRIND/bin:$PATH
468 GIT_EXEC_PATH=$GIT_VALGRIND/bin
470 elif test -n "$GIT_TEST_INSTALLED" ; then
471 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
472 error "Cannot run git from $GIT_TEST_INSTALLED."
473 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
474 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
475 else # normal case, use ../bin-wrappers only unless $with_dashes:
476 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
477 if ! test -x "$git_bin_dir/git" ; then
478 if test -z "$with_dashes" ; then
479 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
483 PATH="$git_bin_dir:$PATH"
484 GIT_EXEC_PATH=$GIT_BUILD_DIR
485 if test -n "$with_dashes" ; then
486 PATH="$GIT_BUILD_DIR:$PATH"
489 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
491 GIT_CONFIG_NOSYSTEM=1
493 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
495 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
497 if test -z "$GIT_TEST_CMP"
499 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
501 GIT_TEST_CMP="$DIFF -c"
503 GIT_TEST_CMP="$DIFF -u"
507 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
509 test -d "$GIT_BUILD_DIR"/templates/blt || {
510 error "You haven't built things yet, have you?"
513 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
515 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
517 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
518 error "You haven't built git_remote_helpers yet, have you?"
522 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
523 echo >&2 'You need to build test-chmtime:'
524 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
529 test="trash directory.$(basename "$0" .sh)"
530 test -n "$root" && test="$root/$test"
532 /*) TRASH_DIRECTORY="$test" ;;
533 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
535 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
538 echo >&5 "FATAL: Cannot prepare test area"
542 HOME="$TRASH_DIRECTORY"
545 if test -z "$TEST_NO_CREATE_REPO"; then
546 test_create_repo "$test"
550 # Use -P to resolve symlinks in our working directory so that the cwd
551 # in subprocesses like git equals our $PWD (for pathname comparisons).
552 cd -P "$test" || exit 1
555 this_test=${this_test%%-*}
556 for skp in $GIT_SKIP_TESTS
560 say_color skip >&3 "skipping test $this_test altogether"
561 skip_all="skip all tests in $this_test"
566 # Provide an implementation of the 'yes' utility
581 # Fix some commands on Windows
584 # Windows has its own (incompatible) sort and find
594 # git sees Windows-style pwd
598 # no POSIX permissions
599 # backslashes in pathspec are converted to '/'
600 # exec does not inherit the PID
601 test_set_prereq MINGW
602 test_set_prereq SED_STRIPS_CR
605 test_set_prereq POSIXPERM
606 test_set_prereq EXECKEEPSPID
607 test_set_prereq NOT_MINGW
608 test_set_prereq SED_STRIPS_CR
611 test_set_prereq POSIXPERM
612 test_set_prereq BSLASHPSPEC
613 test_set_prereq EXECKEEPSPID
614 test_set_prereq NOT_MINGW
618 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
619 test -z "$NO_PERL" && test_set_prereq PERL
620 test -z "$NO_PYTHON" && test_set_prereq PYTHON
621 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
622 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
624 # Can we rely on git's output in the C locale?
625 if test -n "$GETTEXT_POISON"
627 GIT_GETTEXT_POISON=YesPlease
628 export GIT_GETTEXT_POISON
629 test_set_prereq GETTEXT_POISON
631 test_set_prereq C_LOCALE_OUTPUT
634 # Use this instead of test_cmp to compare files that contain expected and
635 # actual output from git commands that can be translated. When running
636 # under GETTEXT_POISON this pretends that the command produced expected
639 test -n "$GETTEXT_POISON" || test_cmp "$@"
642 # Use this instead of "grep expected-string actual" to see if the
643 # output from a git command that can be translated either contains an
644 # expected string, or does not contain an unwanted one. When running
645 # under GETTEXT_POISON this pretends that the command produced expected
648 if test -n "$GETTEXT_POISON"
651 elif test "x!" = "x$1"
660 # test whether the filesystem supports symbolic links
661 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
664 # When the tests are run as root, permission tests will report that
665 # things are writable when they shouldn't be.
666 test -w / || test_set_prereq SANITY